#
# test03.rb
#
# $Id: test03.rb,v 1.1 2000/11/22 14:36:00 keiko Exp $
#

require "narray"
require "dcl"

include DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = -90
YMAX = +90
DRAD = PI / 180
DZ = 0.05
FACT = 10
p = NArray.sfloat(NX, NY)
u = NArray.sfloat(NX, NY)
v = NArray.sfloat(NX, NY)
alon = NArray.sfloat(NX)
alat = NArray.sfloat(NY)

#-- data ---
alon = alon.indgen(XMIN, (XMAX-XMIN)/(NX-1).to_f)
alat = alat.indgen(YMIN, (YMAX-YMIN)/(NY-1).to_f)
for j in 0..NY-1
  for i in 0..NX-1
    slat = sin(alat[j]*DRAD)
    p[i,j] = cos(alon[i]*DRAD) * (1-slat**2) * sin(2*PI*slat) + DZ
  end
end

rmiss = glrget('RMISS')
gllset('LMISS', true)

for j in 0..NY-1
  for i in 0..NX-1
    if (j == 0 || j == NY-1)
      u[i,j] = rmiss
      v[i,j] = rmiss
    else
      u[i,j] = (p[i,j-1] - p[i,j+1]) * FACT
      v[i,j] = (p[imod(i+1,NX-1),j] - p[imod(i-1,NX-1),j]) * FACT
    end
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm
grswnd(XMIN, XMAX, YMIN, YMAX)
grsvpt(0.1, 0.9, 0.1, 0.9)
grssim(0.4, 0.0, 0.0)
grsmpl(165.0, 60.0, 0.0)
grstxy(-180.0, 180.0, 0.0, 90.0)
grstrn(30)
grstrf
sglset('LCLIP', true)

umlset('LGRIDMJ', false)
umrset('DGRIDMN', 30.0)
umpmap('coast_world')
umpglb

udcntr(p, NX, NX, NY)

for j in 0..NY-1
  for i in 0..NX-1
    if (!(u[i,j] == rmiss || v[i,j] == rmiss))
      sglazu(alon[i],alat[j],alon[i]+u[i,j],alat[j]+v[i,j], 1, 3)
    end
  end
end

grcls

